var MPI_CONFIG_KEY = '__mpi';
/**
 * Get the Segment Wrapper config from window
 * @param {string=} key Key config to extract. If not provided, all the config will be returned
 * @return {any} Config value or all the config if not key provided
 */

export var getConfig = function getConfig(key) {
  var _window, _window$MPI_CONFIG_KE;

  var config = ((_window = window) == null ? void 0 : (_window$MPI_CONFIG_KE = _window[MPI_CONFIG_KEY]) == null ? void 0 : _window$MPI_CONFIG_KE.segmentWrapper) || {};
  return key ? config[key] : config;
};
/**
 * Set a config value to the Segment Wrapper config
 * @param {string} key Config key to update
 * @param {boolean|string|number|object} value Value to set on the config key
 */

export var setConfig = function setConfig(key, value) {
  window[MPI_CONFIG_KEY] = window[MPI_CONFIG_KEY] || {};
  window[MPI_CONFIG_KEY].segmentWrapper = window[MPI_CONFIG_KEY].segmentWrapper || {};
  window[MPI_CONFIG_KEY].segmentWrapper[key] = value;
};