import _asyncToGenerator from "@babel/runtime/helpers/esm/asyncToGenerator";
import _regeneratorRuntime from "@babel/runtime/regenerator";
import { getConfig, setConfig } from './config.js';
import { dispatchEvent } from '@s-ui/js/lib/events';
var USER_DATA_READY_EVENT = 'USER_DATA_READY';
/*
mirar en window si hay los datos (que habría info de si el usuario está logado+hash, no logado o undefined porque aún no se sabe)

-> window.__mpi.segmentWrapper.universalId

si undefined nos subscribiríamos a un evento (to be defined) por el cual recibiríamos la info que se grabaría en el window (podría ser un evento como USER_DATA_READY  lanzado como custom event en el document, quizá no haría falta payload si el dato se graba en window y después se emite evento, dado que los datos son los mismos)

Nosotros esperábamos la forma de subscribirnos xDD necesitáis que os pasemos alguna info?
*/

export var getUniversalIdFromConfig = function getUniversalIdFromConfig() {
  return getConfig('universalId');
};
export var getUniversalId = /*#__PURE__*/function () {
  var _ref = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee() {
    var universalId, userEmail;
    return _regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            // 1. Try to get universalId from config
            universalId = getUniversalIdFromConfig();

            if (!universalId) {
              _context.next = 3;
              break;
            }

            return _context.abrupt("return", universalId);

          case 3:
            // 2. If not available, then we use the email and hash it
            userEmail = getConfig('userEmail');

            if (!userEmail) {
              _context.next = 10;
              break;
            }

            _context.next = 7;
            return import('./hashEmail.js').then(function (_ref2) {
              var createUniversalId = _ref2.createUniversalId;
              return createUniversalId(userEmail);
            })["catch"](function () {
              return undefined;
            });

          case 7:
            universalId = _context.sent;
            setUniversalId(universalId);
            return _context.abrupt("return", universalId);

          case 10:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));

  return function getUniversalId() {
    return _ref.apply(this, arguments);
  };
}();
export var getUniversalIdAndNotify = /*#__PURE__*/function () {
  var _ref3 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee2() {
    var universalId;
    return _regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            _context2.next = 2;
            return getUniversalId();

          case 2:
            universalId = _context2.sent;
            dispatchEvent({
              eventName: USER_DATA_READY_EVENT,
              detail: {
                universalId: universalId
              }
            });
            return _context2.abrupt("return", universalId);

          case 5:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  }));

  return function getUniversalIdAndNotify() {
    return _ref3.apply(this, arguments);
  };
}();
export var setUniversalId = function setUniversalId(universalId) {
  return setConfig('universalId', universalId);
};